From 31f772c7d8db888df7fd62683d99b8513738bca0 Mon Sep 17 00:00:00 2001
From: Bhushan Narkhede <bnarkhede@marvell.com>
Date: Wed, 30 Nov 2022 03:24:08 -0800
References: jsc#PED-1539
Upstream: no
Subject: [PATCH] Marvell core changes and dummy plugin v5.9.7

---
 conf/Makefile.am                              |   1 +
 conf/options/charon.opt                       |   3 +
 conf/plugins/auth-els.opt                     |   5 +
 configure.ac                                  |  27 ++
 src/charon-cmd/cmd/cmd_connection.c           |  24 +-
 src/charon-nm/nm/nm_service.c                 |  24 +-
 src/charon/Makefile.am                        |   4 +
 src/libcharon/Makefile.am                     |   8 +
 src/libcharon/config/ike_cfg.c                |  58 ++-
 src/libcharon/config/peer_cfg.c               |  29 ++
 src/libcharon/config/peer_cfg.h               |  31 ++
 src/libcharon/encoding/parser.c               |  35 ++
 .../payloads/traffic_selector_substructure.c  |  82 +++-
 .../payloads/traffic_selector_substructure.h  |  17 +
 src/libcharon/kernel/kernel_fc_sp.c           |  61 +++
 src/libcharon/kernel/kernel_fc_sp.h           | 366 ++++++++++++++++++
 src/libcharon/kernel/kernel_interface.c       | 188 ++++++++-
 src/libcharon/kernel/kernel_interface.h       |  50 ++-
 src/libcharon/kernel/kernel_ipsec.h           |  23 ++
 src/libcharon/network/sender.c                |  53 ++-
 src/libcharon/network/socket.h                |  27 ++
 src/libcharon/network/socket_manager.c        | 151 ++++++--
 src/libcharon/network/socket_manager.h        |  24 +-
 src/libcharon/plugins/auth_els/Makefile.am    |  25 ++
 .../plugins/auth_els/auth_els_configs.c       | 183 +++++++++
 .../plugins/auth_els/auth_els_configs.h       |  41 ++
 src/libcharon/plugins/auth_els/auth_els_ike.c | 270 +++++++++++++
 src/libcharon/plugins/auth_els/auth_els_ike.h |  42 ++
 .../plugins/auth_els/auth_els_kernel_fc_sp.c  | 235 +++++++++++
 .../plugins/auth_els/auth_els_kernel_fc_sp.h  |  35 ++
 .../plugins/auth_els/auth_els_plugin.c        | 213 ++++++++++
 .../plugins/auth_els/auth_els_plugin.h        |  46 +++
 .../plugins/auth_els/auth_els_socket.c        | 114 ++++++
 .../plugins/auth_els/auth_els_socket.h        |  29 ++
 .../plugins/auth_els/auth_els_utils.h         |  60 +++
 src/libcharon/plugins/ha/ha_tunnel.c          |  24 +-
 .../kernel_netlink/kernel_netlink_net.c       |   2 +-
 .../plugins/kernel_pfkey/kernel_pfkey_ipsec.c |  24 +-
 .../plugins/kernel_wfp/kernel_wfp_ipsec.c     |  23 ++
 .../plugins/load_tester/load_tester_config.c  |  24 +-
 src/libcharon/plugins/medcli/medcli_config.c  |  26 +-
 src/libcharon/plugins/medsrv/medsrv_config.c  |  24 +-
 src/libcharon/plugins/sql/sql_config.c        |  24 +-
 .../plugins/stroke/stroke_attribute.c         |  23 ++
 src/libcharon/plugins/stroke/stroke_config.c  |  28 +-
 src/libcharon/plugins/stroke/stroke_list.c    |  30 ++
 src/libcharon/plugins/uci/uci_config.c        |  26 +-
 src/libcharon/plugins/vici/vici_attribute.c   |  25 +-
 src/libcharon/plugins/vici/vici_config.c      |  39 +-
 src/libcharon/plugins/vici/vici_control.c     |  24 +-
 src/libcharon/processing/jobs/migrate_job.c   |  24 +-
 src/libcharon/sa/child_sa.c                   |  38 +-
 src/libcharon/sa/child_sa.h                   |  32 ++
 src/libcharon/sa/ike_sa.c                     |  49 ++-
 src/libcharon/sa/ike_sa.h                     |  25 ++
 src/libcharon/sa/ike_sa_manager.c             |  48 ++-
 src/libcharon/sa/ike_sa_manager.h             |  36 ++
 src/libcharon/sa/ikev1/tasks/informational.c  |  24 +-
 src/libcharon/sa/ikev1/tasks/isakmp_natd.c    |  24 +-
 src/libcharon/sa/ikev2/task_manager_v2.c      |  26 +-
 src/libcharon/sa/ikev2/tasks/child_create.c   |  27 +-
 src/libcharon/sa/ikev2/tasks/ike_mobike.c     |  27 +-
 src/libcharon/sa/ikev2/tasks/ike_natd.c       |  37 +-
 src/libstrongswan/networking/host.c           |  46 ++-
 src/libstrongswan/networking/host.h           |  31 ++
 .../selectors/traffic_selector.c              |  90 ++++-
 .../selectors/traffic_selector.h              |  49 +++
 src/libstrongswan/utils/identification.c      |  35 +-
 src/libstrongswan/utils/identification.h      |  28 ++
 src/libstrongswan/utils/parser_helper.c       | 114 +++++-
 src/libstrongswan/utils/utils.h               |  29 ++
 src/swanctl/swanctl.c                         |  94 +++++
 74 files changed, 3816 insertions(+), 115 deletions(-)
 create mode 100644 conf/plugins/auth-els.opt
 create mode 100644 src/libcharon/kernel/kernel_fc_sp.c
 create mode 100644 src/libcharon/kernel/kernel_fc_sp.h
 create mode 100644 src/libcharon/plugins/auth_els/Makefile.am
 create mode 100644 src/libcharon/plugins/auth_els/auth_els_configs.c
 create mode 100644 src/libcharon/plugins/auth_els/auth_els_configs.h
 create mode 100644 src/libcharon/plugins/auth_els/auth_els_ike.c
 create mode 100644 src/libcharon/plugins/auth_els/auth_els_ike.h
 create mode 100644 src/libcharon/plugins/auth_els/auth_els_kernel_fc_sp.c
 create mode 100644 src/libcharon/plugins/auth_els/auth_els_kernel_fc_sp.h
 create mode 100644 src/libcharon/plugins/auth_els/auth_els_plugin.c
 create mode 100644 src/libcharon/plugins/auth_els/auth_els_plugin.h
 create mode 100644 src/libcharon/plugins/auth_els/auth_els_socket.c
 create mode 100644 src/libcharon/plugins/auth_els/auth_els_socket.h
 create mode 100644 src/libcharon/plugins/auth_els/auth_els_utils.h

diff --git a/conf/Makefile.am b/conf/Makefile.am
index 74fb63680..540a3b563 100644
--- a/conf/Makefile.am
+++ b/conf/Makefile.am
@@ -32,6 +32,7 @@ plugins = \
 	plugins/android_log.opt \
 	plugins/attr.opt \
 	plugins/attr-sql.opt \
+	plugins/auth-els.opt \
 	plugins/bliss.opt \
 	plugins/botan.opt \
 	plugins/bypass-lan.opt \
diff --git a/conf/options/charon.opt b/conf/options/charon.opt
index 7d00e1a8c..3fef9d35b 100644
--- a/conf/options/charon.opt
+++ b/conf/options/charon.opt
@@ -420,6 +420,9 @@ charon.send_delay_request = yes
 charon.send_delay_type = 0
 	Specific IKEv2 message type to delay, 0 for any.
 
+charon.sender_thread_count = 1
+        For applications that require connection scaling, this allows creation of multiples threads to do sends.
+
 charon.send_vendor_id = no
 	Send strongSwan vendor ID payload
 
diff --git a/conf/plugins/auth-els.opt b/conf/plugins/auth-els.opt
new file mode 100644
index 000000000..38b670c94
--- /dev/null
+++ b/conf/plugins/auth-els.opt
@@ -0,0 +1,5 @@
+charon.plugins.auth-els.disabled_remotes.remote_1.wwpn = 21:00:00:24:ff:78:30:c5
+	WWPN of remote port.
+
+charon.plugins.auth-els.disabled_remotes.remote_1.wwpn_separator = . : -
+	WWPN separated by : . -.
diff --git a/configure.ac b/configure.ac
index dd9d128c1..06a9ad284 100644
--- a/configure.ac
+++ b/configure.ac
@@ -16,6 +16,28 @@
 # for more details.
 #
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 # ============================
 #  initialize & set some vars
 # ============================
@@ -215,6 +237,7 @@ ARG_ENABL_SET([eap-tnc],        [enable EAP TNC trusted network connect module.]
 ARG_ENABL_SET([eap-dynamic],    [enable dynamic EAP proxy module.])
 ARG_ENABL_SET([eap-radius],     [enable RADIUS proxy authentication module.])
 ARG_ENABL_SET([ext-auth],       [enable plugin calling an external authorization script.])
+ARG_ENABL_SET([auth-els],       [enable auth els plugin authorization module.])
 ARG_ENABL_SET([ipseckey],       [enable IPSECKEY authentication plugin.])
 ARG_ENABL_SET([keychain],       [enables OS X Keychain Services credential set.])
 ARG_ENABL_SET([pkcs11],         [enables the PKCS11 token support plugin.])
@@ -1571,6 +1594,7 @@ ADD_PLUGIN([kernel-wfp],           [c charon])
 ADD_PLUGIN([kernel-iph],           [c charon])
 ADD_PLUGIN([kernel-pfkey],         [c charon starter nm cmd])
 ADD_PLUGIN([kernel-pfroute],       [c charon starter nm cmd])
+ADD_PLUGIN([auth-els],             [c charon])
 ADD_PLUGIN([kernel-netlink],       [c charon starter nm cmd])
 ADD_PLUGIN([selinux],              [c charon starter nm cmd])
 ADD_PLUGIN([resolve],              [c charon cmd])
@@ -1755,6 +1779,8 @@ AM_CONDITIONAL(USE_KERNEL_WFP, test x$kernel_wfp = xtrue)
 AM_CONDITIONAL(USE_KERNEL_IPH, test x$kernel_iph = xtrue)
 AM_CONDITIONAL(USE_WHITELIST, test x$whitelist = xtrue)
 AM_CONDITIONAL(USE_EXT_AUTH, test x$ext_auth = xtrue)
+AM_CONDITIONAL(USE_AUTH_ELS, test x$auth_els = xtrue)
+AM_CONDITIONAL(USE_DISABLE_SIGNAL_HANDLER, test x$auth_els = xtrue)
 AM_CONDITIONAL(USE_LOOKIP, test x$lookip = xtrue)
 AM_CONDITIONAL(USE_ERROR_NOTIFY, test x$error_notify = xtrue)
 AM_CONDITIONAL(USE_CERTEXPIRE, test x$certexpire = xtrue)
@@ -2102,6 +2128,7 @@ AC_CONFIG_FILES([
 	src/libcharon/plugins/kernel_iph/Makefile
 	src/libcharon/plugins/whitelist/Makefile
 	src/libcharon/plugins/ext_auth/Makefile
+	src/libcharon/plugins/auth_els/Makefile
 	src/libcharon/plugins/lookip/Makefile
 	src/libcharon/plugins/error_notify/Makefile
 	src/libcharon/plugins/certexpire/Makefile
diff --git a/src/charon-cmd/cmd/cmd_connection.c b/src/charon-cmd/cmd/cmd_connection.c
index 8c09cac89..0467882da 100644
--- a/src/charon-cmd/cmd/cmd_connection.c
+++ b/src/charon-cmd/cmd/cmd_connection.c
@@ -15,6 +15,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include "cmd_connection.h"
 
 #include <signal.h>
@@ -180,7 +202,7 @@ static peer_cfg_t* create_peer_cfg(private_cmd_connection_t *this)
 			break;
 	}
 
-	ike.local_port = charon->socket->get_port(charon->socket, FALSE);
+	ike.local_port = charon->socket->get_port(charon->socket, SOCKET_FAMILY_BOTH, FALSE);
 	if (ike.local_port != IKEV2_UDP_PORT)
 	{
 		ike.remote_port = IKEV2_NATT_PORT;
diff --git a/src/charon-nm/nm/nm_service.c b/src/charon-nm/nm/nm_service.c
index 5d6d32950..07c3ab049 100644
--- a/src/charon-nm/nm/nm_service.c
+++ b/src/charon-nm/nm/nm_service.c
@@ -15,6 +15,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include "nm_service.h"
 
 #include <daemon.h>
@@ -614,7 +636,7 @@ static gboolean connect_(NMVpnServicePlugin *plugin, NMConnection *connection,
 	ike_cfg_create_t ike = {
 		.version = IKEV2,
 		.local = "%any",
-		.local_port = charon->socket->get_port(charon->socket, FALSE),
+		.local_port = charon->socket->get_port(charon->socket, SOCKET_FAMILY_BOTH, FALSE),
 		.remote_port = IKEV2_UDP_PORT,
 		.fragmentation = FRAGMENTATION_YES,
 	};
diff --git a/src/charon/Makefile.am b/src/charon/Makefile.am
index b78bbd757..f490be6e6 100644
--- a/src/charon/Makefile.am
+++ b/src/charon/Makefile.am
@@ -17,4 +17,8 @@ charon_LDADD = \
 	$(top_builddir)/src/libcharon/libcharon.la \
 	-lm $(PTHREADLIB) $(ATOMICLIB) $(DLLIB)
 
+if USE_DISABLE_SIGNAL_HANDLER
+  AM_CPPFLAGS += -DDISABLE_SIGNAL_HANDLER
+endif
+
 EXTRA_DIST = Android.mk
diff --git a/src/libcharon/Makefile.am b/src/libcharon/Makefile.am
index fb6de8ebd..af68e1d56 100644
--- a/src/libcharon/Makefile.am
+++ b/src/libcharon/Makefile.am
@@ -47,6 +47,7 @@ encoding/payloads/hash_payload.c encoding/payloads/hash_payload.h \
 encoding/payloads/fragment_payload.c encoding/payloads/fragment_payload.h \
 kernel/kernel_interface.c kernel/kernel_interface.h \
 kernel/kernel_ipsec.c kernel/kernel_ipsec.h \
+kernel/kernel_fc_sp.c kernel/kernel_fc_sp.h \
 kernel/kernel_net.c kernel/kernel_net.h \
 kernel/kernel_listener.h kernel/kernel_handler.c kernel/kernel_handler.h \
 network/receiver.c network/receiver.h network/sender.c network/sender.h \
@@ -327,6 +328,13 @@ if MONOLITHIC
 endif
 endif
 
+if USE_AUTH_ELS
+  SUBDIRS += plugins/auth_els
+if MONOLITHIC
+  libcharon_la_LIBADD += plugins/auth_els/libstrongswan-auth-els.la
+endif
+endif
+
 if USE_EAP_IDENTITY
   SUBDIRS += plugins/eap_identity
 if MONOLITHIC
diff --git a/src/libcharon/config/ike_cfg.c b/src/libcharon/config/ike_cfg.c
index 792f8022a..79cb0b53a 100644
--- a/src/libcharon/config/ike_cfg.c
+++ b/src/libcharon/config/ike_cfg.c
@@ -16,6 +16,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #define _GNU_SOURCE /* for stdndup() */
 #include <string.h>
 
@@ -120,6 +142,11 @@ struct private_ike_cfg_t {
 	 * List of proposals to use
 	 */
 	linked_list_t *proposals;
+	
+	/**
+	 * Indicates that this config is for FC_ADDR 
+	 */
+	bool fc_addr;
 };
 
 METHOD(ike_cfg_t, get_version, ike_version_t,
@@ -198,7 +225,7 @@ METHOD(ike_cfg_t, resolve_other, host_t*,
 /**
  * Common function for match_me/other
  */
-static u_int match(linked_list_t *hosts, linked_list_t *ranges, host_t *cand)
+static u_int match(linked_list_t *hosts, linked_list_t *ranges, host_t *cand, bool fc_addr)
 {
 	enumerator_t *enumerator;
 	traffic_selector_t *ts;
@@ -211,6 +238,11 @@ static u_int match(linked_list_t *hosts, linked_list_t *ranges, host_t *cand)
 	enumerator = hosts->create_enumerator(hosts);
 	while (enumerator->enumerate(enumerator, &str))
 	{
+		if (cand->get_family(cand) == AF_NETLINK && !fc_addr)
+		{
+			DBG1 (DBG_IKE, "ike_cfg.c: Looking for FC addr but this ike_cfg is not for FC");
+			continue;
+		}
 		host = host_create_from_dns(str, cand->get_family(cand), 0);
 		if (host)
 		{
@@ -252,13 +284,13 @@ static u_int match(linked_list_t *hosts, linked_list_t *ranges, host_t *cand)
 METHOD(ike_cfg_t, match_me, u_int,
 	private_ike_cfg_t *this, host_t *host)
 {
-	return match(this->my_hosts, this->my_ranges, host);
+	return match(this->my_hosts, this->my_ranges, host, this->fc_addr);
 }
 
 METHOD(ike_cfg_t, match_other, u_int,
 	private_ike_cfg_t *this, host_t *host)
 {
-	return match(this->other_hosts, this->other_ranges, host);
+	return match(this->other_hosts, this->other_ranges, host, this->fc_addr);
 }
 
 METHOD(ike_cfg_t, get_my_addr, char*,
@@ -451,7 +483,7 @@ static traffic_selector_t* make_range(char *str)
 	{
 		return NULL;
 	}
-	if (to->get_family(to) == AF_INET)
+	if (to->get_family(to) == AF_INET || to->get_family(to) == AF_NETLINK)
 	{
 		type = TS_IPV4_ADDR_RANGE;
 	}
@@ -507,6 +539,12 @@ int ike_cfg_get_family(ike_cfg_t *cfg, bool local)
 	char *str;
 	int family = AF_UNSPEC;
 
+	// If this config is for FC, then we don't have to look any further.
+	if (this->fc_addr)
+	{
+		return AF_NETLINK;
+	}
+
 	if (local)
 	{
 		enumerator = this->my_hosts->create_enumerator(this->my_hosts);
@@ -553,6 +591,12 @@ bool ike_cfg_has_address(ike_cfg_t *cfg, host_t *addr, bool local)
 	char *str;
 	bool found = FALSE;
 
+	// If this config is for FC then make sure that is what they are looking for
+	if ((addr->get_family (addr) == AF_NETLINK) && !this->fc_addr)
+	{
+		return false;
+	}
+
 	if (local)
 	{
 		enumerator = this->my_hosts->create_enumerator(this->my_hosts);
@@ -626,6 +670,12 @@ ike_cfg_t *ike_cfg_create(ike_cfg_create_t *data)
 		.proposals = linked_list_create(),
 	);
 
+	if (strstr (data->local, "-fcsp") && strstr (data->remote, "-fcsp"))
+	{
+		this->fc_addr = true;
+		data->local[strlen (data->local) - 5] = '\0';
+		data->remote[strlen (data->remote) - 5] = '\0';
+	}
 	parse_addresses(data->local, this->my_hosts, this->my_ranges);
 	parse_addresses(data->remote, this->other_hosts, this->other_ranges);
 
diff --git a/src/libcharon/config/peer_cfg.c b/src/libcharon/config/peer_cfg.c
index f08eef502..0c2da66cd 100644
--- a/src/libcharon/config/peer_cfg.c
+++ b/src/libcharon/config/peer_cfg.c
@@ -16,6 +16,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include <string.h>
 
 #include "peer_cfg.h"
@@ -213,6 +235,12 @@ METHOD(peer_cfg_t, get_ike_cfg, ike_cfg_t*,
 	return this->ike_cfg;
 }
 
+METHOD(peer_cfg_t, set_ike_cfg, void,
+	private_peer_cfg_t *this, ike_cfg_t* ike_cfg)
+{
+	this->ike_cfg = ike_cfg;
+}
+
 METHOD(peer_cfg_t, add_child_cfg, void,
 	private_peer_cfg_t *this, child_cfg_t *child_cfg)
 {
@@ -822,6 +850,7 @@ peer_cfg_t *peer_cfg_create(char *name, ike_cfg_t *ike_cfg,
 			.get_name = _get_name,
 			.get_ike_version = _get_ike_version,
 			.get_ike_cfg = _get_ike_cfg,
+			.set_ike_cfg = _set_ike_cfg,
 			.add_child_cfg = _add_child_cfg,
 			.remove_child_cfg = (void*)_remove_child_cfg,
 			.replace_child_cfgs = _replace_child_cfgs,
diff --git a/src/libcharon/config/peer_cfg.h b/src/libcharon/config/peer_cfg.h
index 6b0834339..24783a7e3 100644
--- a/src/libcharon/config/peer_cfg.h
+++ b/src/libcharon/config/peer_cfg.h
@@ -16,6 +16,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 /**
  * @defgroup peer_cfg peer_cfg
  * @{ @ingroup config
@@ -141,6 +163,15 @@ struct peer_cfg_t {
 	 */
 	ike_cfg_t* (*get_ike_cfg) (peer_cfg_t *this);
 
+	/**
+	 * Set the IKE config to use for initiation.
+         * This is needed for FCSP2 because the ike_cfg is not created
+         * correctly by vici as it doesn't have all of the information.
+	 *
+	 * @param				the IKE config to use
+	 */
+        void (*set_ike_cfg) (peer_cfg_t *this, ike_cfg_t* ike_cfg);
+
 	/**
 	 * Attach a CHILD config.
 	 *
diff --git a/src/libcharon/encoding/parser.c b/src/libcharon/encoding/parser.c
index 546d39931..38d81cc48 100644
--- a/src/libcharon/encoding/parser.c
+++ b/src/libcharon/encoding/parser.c
@@ -15,6 +15,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include <stdlib.h>
 #include <string.h>
 
@@ -369,9 +391,11 @@ METHOD(parser_t, parse_payload, status_t,
 	payload_t *pld;
 	void *output;
 	int payload_length = 0, spi_size = 0, attribute_length = 0, header_length;
+	uint8_t ts_type = 0;
 	bool attribute_format = FALSE;
 	int rule_number, rule_count;
 	encoding_rule_t *rule;
+	payload_type_t pld_type = 0;
 
 	/* create instance of the payload to parse */
 	if (payload_is_known(payload_type, this->major_version))
@@ -389,6 +413,7 @@ METHOD(parser_t, parse_payload, status_t,
 	DBG3(DBG_ENC, "parsing payload from %b",
 		 this->byte_pos, (u_int)(this->input_roof - this->byte_pos));
 
+	pld_type = pld->get_type(pld);
 	/* base pointer for output, avoids casting in every rule */
 	output = pld;
 	/* parse the payload with its own rules */
@@ -420,6 +445,16 @@ METHOD(parser_t, parse_payload, status_t,
 					pld->destroy(pld);
 					return PARSE_ERROR;
 				}
+				if (pld_type == PLV2_TRAFFIC_SELECTOR_SUBSTRUCTURE)
+				{
+					ts_type = *(uint8_t*)(output + rule->offset);
+					if(ts_type == TS_FC_ADDR_RANGE)
+					{
+						traffic_selector_substructure_t *tsstruct = (traffic_selector_substructure_t*)pld;
+						tsstruct->set_ts_type(tsstruct, TS_FC_ADDR_RANGE);
+						rule_count = pld->get_encoding_rules(pld, &this->rules);
+					}
+				}
 				break;
 			}
 			case U_INT_16:
diff --git a/src/libcharon/encoding/payloads/traffic_selector_substructure.c b/src/libcharon/encoding/payloads/traffic_selector_substructure.c
index 8fbcdf98c..ed1caad08 100644
--- a/src/libcharon/encoding/payloads/traffic_selector_substructure.c
+++ b/src/libcharon/encoding/payloads/traffic_selector_substructure.c
@@ -16,6 +16,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include "traffic_selector_substructure.h"
 
 #include <encoding/payloads/encodings.h>
@@ -122,6 +144,9 @@ static bool parse_ts_data(private_traffic_selector_substructure_t *this,
 		case TS_IPV6_ADDR_RANGE:
 			addr_len = 16;
 			break;
+		case TS_FC_ADDR_RANGE:
+			addr_len = 3;
+			break;
 		default:
 			return FALSE;
 	}
@@ -166,6 +191,32 @@ METHOD(payload_t, verify, status_t,
 			}
 			break;
 		}
+		case TS_FC_ADDR_RANGE:
+		{
+			uint16_t start_port, end_port;
+			chunk_t start_addr, end_addr;
+
+			if (!parse_ts_data(this, &start_port, &end_port, &start_addr,
+							   &end_addr))
+			{
+				return FAILED;
+			}
+
+			if (start_port > end_port)
+			{
+				/* OPAQUE ports are the only exception */
+				if (start_port != 0xffff && end_port != 0)
+				{
+					return FAILED;
+				}
+			}
+			if ((start_addr.len != 3) ||
+				(start_addr.len != 3))
+			{
+				return FAILED;
+			}
+			break;
+		}
 		case TS_SECLABEL:
 			if (!this->ts_data.len)
 			{
@@ -215,9 +266,26 @@ METHOD(payload_t, get_length, size_t,
 	return this->payload_length;
 }
 
+METHOD(traffic_selector_substructure_t, set_ts_type, void,
+	private_traffic_selector_substructure_t *this, ts_type_t ts_type)
+{
+	this->ts_type = ts_type;
+	if (this->ts_type == TS_FC_ADDR_RANGE)
+	{
+		this->payload_length = get_header_length(this) + 10; //starting address(3), ending address(3)
+	}
+}
+
+METHOD(traffic_selector_substructure_t, get_ts_type, ts_type_t,
+	private_traffic_selector_substructure_t *this)
+{
+	return this->ts_type;
+}
+
 METHOD(traffic_selector_substructure_t, get_traffic_selector, traffic_selector_t*,
 	private_traffic_selector_substructure_t *this)
 {
+	traffic_selector_t* ts = NULL;
 	uint16_t start_port, end_port;
 	chunk_t start_addr, end_addr;
 
@@ -225,9 +293,18 @@ METHOD(traffic_selector_substructure_t, get_traffic_selector, traffic_selector_t
 	{
 		return NULL;
 	}
+	if (this->ts_type == TS_FC_ADDR_RANGE)
+	{
+		ts = traffic_selector_create_from_fcsp2_format(start_addr, start_port,
+				end_addr, end_port);
+	}
+	else
+	{
 	return traffic_selector_create_from_bytes(
 									this->ip_protocol_id, this->ts_type,
 									start_addr, start_port, end_addr, end_port);
+    }
+    return ts;
 }
 
 METHOD(traffic_selector_substructure_t, get_sec_label, sec_label_t*,
@@ -266,6 +343,8 @@ traffic_selector_substructure_t *traffic_selector_substructure_create()
 				.get_type = _get_type,
 				.destroy = _destroy,
 			},
+			.get_ts_type = _get_ts_type,
+			.set_ts_type = _set_ts_type,
 			.get_traffic_selector = _get_traffic_selector,
 			.get_sec_label = _get_sec_label,
 			.destroy = _destroy,
@@ -290,7 +369,8 @@ traffic_selector_substructure_t *traffic_selector_substructure_create_from_traff
 	this->ts_type = ts->get_type(ts);
 	this->ip_protocol_id = ts->get_protocol(ts);
 
-	writer = bio_writer_create(this->ts_type == TS_IPV4_ADDR_RANGE ? 12 : 36);
+	writer = bio_writer_create(this->ts_type == TS_IPV4_ADDR_RANGE ? 12 : 
+        (this->ts_type == TS_FC_ADDR_RANGE) ? 14 : 36);
 	writer->write_uint16(writer, ts->get_from_port(ts));
 	writer->write_uint16(writer, ts->get_to_port(ts));
 	writer->write_data(writer, ts->get_from_address(ts));
diff --git a/src/libcharon/encoding/payloads/traffic_selector_substructure.h b/src/libcharon/encoding/payloads/traffic_selector_substructure.h
index 57d940043..c8bf58815 100644
--- a/src/libcharon/encoding/payloads/traffic_selector_substructure.h
+++ b/src/libcharon/encoding/payloads/traffic_selector_substructure.h
@@ -44,6 +44,23 @@ struct traffic_selector_substructure_t {
 	 */
 	payload_t payload_interface;
 
+	/**
+	 * Get the type of Traffic selector.
+	 *
+	 * @return			type of traffic selector
+	 *
+	 */
+	ts_type_t (*get_ts_type) (traffic_selector_substructure_t *this);
+
+	/**
+	 * Set the type of Traffic selector.
+	 *
+	 * @param ts_type	type of traffic selector
+	 */
+	void (*set_ts_type) (traffic_selector_substructure_t *this,
+						 ts_type_t ts_type);
+
+
 	/**
 	 * Get a traffic_selector_t from this substructure if possible.
 	 *
